'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IntervalRenderer = function (_React$Component) {
    _inherits(IntervalRenderer, _React$Component);

    function IntervalRenderer(props) {
        _classCallCheck(this, IntervalRenderer);

        var _this = _possibleConstructorReturn(this, (IntervalRenderer.__proto__ || Object.getPrototypeOf(IntervalRenderer)).call(this, props));

        _this.handleTick = _this.handleTick.bind(_this);
        return _this;
    }

    _createClass(IntervalRenderer, [{
        key: 'componentDidMount',
        value: function () {
            function componentDidMount() {
                var interval = this.props.interval;

                this.countdown = setInterval(this.handleTick, interval);
            }

            return componentDidMount;
        }()
    }, {
        key: 'componentDidUpdate',
        value: function () {
            function componentDidUpdate() {
                var componentDidRerender = this.props.componentDidRerender;

                componentDidRerender();
            }

            return componentDidUpdate;
        }()
    }, {
        key: 'componentWillUnmount',
        value: function () {
            function componentWillUnmount() {
                clearInterval(this.countdown);
            }

            return componentWillUnmount;
        }()
    }, {
        key: 'handleTick',
        value: function () {
            function handleTick() {
                var shouldComponentRerender = this.props.shouldComponentRerender;


                if (shouldComponentRerender()) {
                    this.forceUpdate();
                }
            }

            return handleTick;
        }()
    }, {
        key: 'renderChildren',
        value: function () {
            function renderChildren(children) {
                return _react2['default'].Children.map(children, function (child) {
                    return _react2['default'].cloneElement(child, {
                        __renderTime: +new Date()
                    });
                });
            }

            return renderChildren;
        }()
    }, {
        key: 'render',
        value: function () {
            function render() {
                var children = this.props.children;


                return _react2['default'].createElement(
                    'div',
                    {
                        style: {
                            height: 'inherit',
                            width: 'inherit'
                        }
                    },
                    this.renderChildren(children)
                );
            }

            return render;
        }()
    }]);

    return IntervalRenderer;
}(_react2['default'].Component);

IntervalRenderer.propTypes = {
    children: _propTypes2['default'].node.isRequired,
    interval: _propTypes2['default'].number,
    shouldComponentRerender: _propTypes2['default'].func,
    componentDidRerender: _propTypes2['default'].func
};

IntervalRenderer.defaultProps = {
    interval: 1000,
    shouldComponentRerender: function () {
        function shouldComponentRerender() {
            return true;
        }

        return shouldComponentRerender;
    }(),
    componentDidRerender: function () {
        function componentDidRerender(f) {
            return f;
        }

        return componentDidRerender;
    }()
};

exports['default'] = IntervalRenderer;